Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4105)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4106)
@@ -20,6 +20,6 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
@@ -43,7 +43,4 @@
 !>
 !> @todo Convert variable if type of given values do not fit specified type.
-!> @todo Remove unused variables
-!> @todo How to deal with definition calls after dom_start_output is called? Should it be allowed
-!>       to define new files after that (which is technically possible)?
 !> @todo Remove iwp from index (and similar) variables.
 !--------------------------------------------------------------------------------------------------!
@@ -52,25 +49,14 @@
    USE kinds
 
-   USE data_output_netcdf4_serial_module, &
-      ONLY: netcdf4_serial_init_dimension, &
-            netcdf4_serial_get_error_message, &
-            netcdf4_serial_init_end, &
-            netcdf4_serial_init_module, &
-            netcdf4_serial_init_variable, &
-            netcdf4_serial_finalize, &
-            netcdf4_serial_open_file, &
-            netcdf4_serial_write_attribute, &
-            netcdf4_serial_write_variable
-
-   USE data_output_netcdf4_parallel_module, &
-      ONLY: netcdf4_parallel_init_dimension, &
-            netcdf4_parallel_get_error_message, &
-            netcdf4_parallel_init_end, &
-            netcdf4_parallel_init_module, &
-            netcdf4_parallel_init_variable, &
-            netcdf4_parallel_finalize, &
-            netcdf4_parallel_open_file, &
-            netcdf4_parallel_write_attribute, &
-            netcdf4_parallel_write_variable
+   USE data_output_netcdf4_module, &
+      ONLY: netcdf4_init_dimension, &
+            netcdf4_get_error_message, &
+            netcdf4_init_end, &
+            netcdf4_init_module, &
+            netcdf4_init_variable, &
+            netcdf4_finalize, &
+            netcdf4_open_file, &
+            netcdf4_write_attribute, &
+            netcdf4_write_variable
 
    USE data_output_binary_module, &
@@ -105,5 +91,4 @@
       INTEGER(iwp)           ::  id = 0               !< id within file
       LOGICAL                ::  is_global = .FALSE.  !< true if global variable
-      LOGICAL                ::  is_init = .FALSE.    !< true if initialized
       CHARACTER(LEN=charlen), DIMENSION(:), ALLOCATABLE ::  dimension_names  !< list of dimension names
       INTEGER(iwp),           DIMENSION(:), ALLOCATABLE ::  dimension_ids    !< list of dimension ids
@@ -118,5 +103,4 @@
       INTEGER(iwp)           ::  length_mask          !< length of masked dimension
       INTEGER(iwp)           ::  var_id = 0           !< associated variable id within file
-      LOGICAL                ::  is_init = .FALSE.    !< true if initialized
       LOGICAL                ::  is_masked = .FALSE.  !< true if masked
       INTEGER(iwp),    DIMENSION(2)              ::  bounds                !< lower and upper bound of dimension
@@ -125,5 +109,5 @@
       INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  masked_values_int16   !< masked dimension values if 16bit integer
       INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE ::  masked_values_int32   !< masked dimension values if 32bit integer
-      INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  masked_values_intwp   !< masked dimension values if working-precision integer
+      INTEGER(iwp),    DIMENSION(:), ALLOCATABLE ::  masked_values_intwp   !< masked dimension values if working-precision int
       INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE ::  values_int8           !< dimension values if 16bit integer
       INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE ::  values_int16          !< dimension values if 16bit integer
@@ -252,7 +236,5 @@
    CALL binary_init_module( debug_output_unit, debug_output, no_var_id )
 
-   CALL netcdf4_serial_init_module( debug_output_unit, debug_output, no_var_id )
-
-   CALL netcdf4_parallel_init_module( debug_output_unit, debug_output, no_var_id )
+   CALL netcdf4_init_module( debug_output_unit, debug_output, no_var_id )
 
 END SUBROUTINE dom_init
@@ -310,5 +292,6 @@
    !             WRITE(*,'(10X,5(I5,1X),A)') files(f)%dimensions(d)%values_int32(0:MIN(4,files(f)%dimensions(d)%length)), '...'
    !          ELSE
-   !             WRITE(*,'(10X,5(F8.2,1X),A)') files(f)%dimensions(d)%values_real64(0:MIN(4,files(f)%dimensions(d)%length)), '...'
+   !             WRITE(*,'(10X,5(F8.2,1X),A)')  &
+   !                files(f)%dimensions(d)%values_real64(0:MIN(4,files(f)%dimensions(d)%length)), '...'
    !          ENDIF
    !          IF ( ALLOCATED(files(f)%dimensions(d)%mask) )  THEN
@@ -716,7 +699,7 @@
 
       return_value = 1
-      CALL internal_message( 'error', routine_name //                   &
-                                      ': dimension ' // TRIM( name ) // &
-                                      ': At least one but no more than two bounds must be given' )
+      CALL internal_message( 'error', routine_name //          &
+                             ': dimension ' // TRIM( name ) // &
+                             ': At least one but no more than two bounds must be given' )
 
    ENDIF
@@ -729,5 +712,13 @@
          IF ( TRIM( filename ) == files(f)%name )  THEN
 
-            IF ( .NOT. ALLOCATED( files(f)%dimensions ) )  THEN
+            IF ( files(f)%is_init )  THEN
+
+               return_value = 1
+               CALL internal_message( 'error',                           &
+                       routine_name // ': file "' // TRIM( filename ) // &
+                       '" is already initialized. No further dimension definition allowed!' )
+               EXIT
+
+            ELSEIF ( .NOT. ALLOCATED( files(f)%dimensions ) )  THEN
 
                ndim = 1
@@ -736,27 +727,45 @@
             ELSE
 
-               ndim = SIZE( files(f)%dimensions )
-
-               !-- Check if dimension already exists in file
-               DO  d = 1, ndim
-                  IF ( files(f)%dimensions(d)%name == dimension%name )  THEN
-                     return_value = 1
-                     CALL internal_message( 'error',            &
-                             routine_name //                    &
-                             ': dimension "' // TRIM( name ) // &
-                             '" already exists in file "' // TRIM( filename ) // '"' )
-                     EXIT
+               !-- Check if any variable of the same name as the new dimension is already defined
+               IF ( ALLOCATED( files(f)%variables ) )  THEN
+                  DO  i = 1, SIZE( files(f)%variables )
+                     IF ( files(f)%variables(i)%name == dimension%name )  THEN
+                        return_value = 1
+                        CALL internal_message( 'error', routine_name //                   &
+                                               ': file "' // TRIM( filename ) //          &
+                                               '" already has a variable of name "' //    &
+                                               TRIM( dimension%name ) // '" defined. ' // &
+                                               'Defining a dimension of the same ' //     &
+                                               'name is not allowed.' )
+                        EXIT
+                     ENDIF
+                  ENDDO
+               ENDIF
+
+               IF ( return_value == 0 )  THEN
+                  !-- Check if dimension already exists in file
+                  ndim = SIZE( files(f)%dimensions )
+
+                  DO  d = 1, ndim
+                     IF ( files(f)%dimensions(d)%name == dimension%name )  THEN
+                        return_value = 1
+                        CALL internal_message( 'error',            &
+                                routine_name //                    &
+                                ': dimension "' // TRIM( name ) // &
+                                '" already exists in file "' // TRIM( filename ) // '"' )
+                        EXIT
+                     ENDIF
+                  ENDDO
+
+                  !-- Extend dimension list
+                  IF ( return_value == 0 )  THEN
+                     ALLOCATE( dims_tmp(ndim) )
+                     dims_tmp = files(f)%dimensions
+                     DEALLOCATE( files(f)%dimensions )
+                     ndim = ndim + 1
+                     ALLOCATE( files(f)%dimensions(ndim) )
+                     files(f)%dimensions(:ndim-1) = dims_tmp
+                     DEALLOCATE( dims_tmp )
                   ENDIF
-               ENDDO
-
-               !-- Extend dimension list
-               IF ( return_value == 0 )  THEN
-                  ALLOCATE( dims_tmp(ndim) )
-                  dims_tmp = files(f)%dimensions
-                  DEALLOCATE( files(f)%dimensions )
-                  ndim = ndim + 1
-                  ALLOCATE( files(f)%dimensions(ndim) )
-                  files(f)%dimensions(:ndim-1) = dims_tmp
-                  DEALLOCATE( dims_tmp )
                ENDIF
 
@@ -832,26 +841,49 @@
       IF ( TRIM( filename ) == files(f)%name )  THEN
 
-         !-- Check if dimensions assigned to variable are defined within file
-         IF ( ALLOCATED( files(f)%dimensions ) )  THEN
-
-            DO  i = 1, SIZE( variable%dimension_names )
-               found = .FALSE.
-               DO  d = 1, SIZE( files(f)%dimensions )
-                  IF ( files(f)%dimensions(d)%name == variable%dimension_names(i) )  THEN
-                     found = .TRUE.
+         IF ( files(f)%is_init )  THEN
+
+            return_value = 1
+            CALL internal_message( 'error', routine_name // ': file "' // TRIM( filename ) // &
+                    '" is already initialized. No further variable definition allowed!' )
+            EXIT
+
+         ELSEIF ( ALLOCATED( files(f)%dimensions ) )  THEN
+
+            !-- Check if any dimension of the same name as the new variable is already defined
+            DO  d = 1, SIZE( files(f)%dimensions )
+               IF ( files(f)%dimensions(d)%name == variable%name )  THEN
+                  return_value = 1
+                  CALL internal_message( 'error', routine_name //                  &
+                                         ': file "' // TRIM( filename ) //         &
+                                         '" already has a dimension of name "' //  &
+                                         TRIM( variable%name ) // '" defined. ' // &
+                                         'Defining a variable of the same name is not allowed.' )
+                  EXIT
+               ENDIF
+            ENDDO
+
+            !-- Check if dimensions assigned to variable are defined within file
+            IF ( return_value == 0 )  THEN
+               DO  i = 1, SIZE( variable%dimension_names )
+                  found = .FALSE.
+                  DO  d = 1, SIZE( files(f)%dimensions )
+                     IF ( files(f)%dimensions(d)%name == variable%dimension_names(i) )  THEN
+                        found = .TRUE.
+                        EXIT
+                     ENDIF
+                  ENDDO
+                  IF ( .NOT. found )  THEN
+                     return_value = 1
+                     CALL internal_message( 'error',                               &
+                                            routine_name //                        &
+                                            ': variable "' // TRIM( name ) //      &
+                                            '" in file "' // TRIM( filename ) //   &
+                                            '": required dimension "' //           &
+                                            TRIM( variable%dimension_names(i) ) // &
+                                            '" not defined' )
                      EXIT
                   ENDIF
                ENDDO
-               IF ( .NOT. found )  THEN
-                  return_value = 1
-                  CALL internal_message( 'error', &
-                                         routine_name //                      &
-                                         ': variable "' // TRIM( name ) //    &
-                                         '" in file "' // TRIM( filename ) // &
-                                         '": required dimension "' //         &
-                                         TRIM( variable%dimension_names(i) ) // '" not defined' )
-                  EXIT
-               ENDIF
-            ENDDO
+            ENDIF
 
          ELSE
@@ -1263,4 +1295,11 @@
 
       IF ( TRIM( filename ) == files(f)%name )  THEN
+
+         IF ( files(f)%is_init )  THEN
+            return_value = 1
+            CALL internal_message( 'error', routine_name // ': file "' // TRIM( filename ) // &
+                    '" is already initialized. No further attribute definition allowed!' )
+            EXIT
+         ENDIF
 
          !-- Add attribute to file
@@ -1328,5 +1367,6 @@
                         !-- Check if attribute already exists
                         DO  a = 1, natt
-                           IF ( files(f)%dimensions(d)%attributes(a)%name == attribute%name )  THEN
+                           IF ( files(f)%dimensions(d)%attributes(a)%name == attribute%name ) &
+                           THEN
                               IF ( append )  THEN
                                  !-- Append existing character attribute
@@ -1385,5 +1425,6 @@
                         !-- Check if attribute already exists
                         DO  a = 1, natt
-                           IF ( files(f)%variables(d)%attributes(a)%name == attribute%name )  THEN
+                           IF ( files(f)%variables(d)%attributes(a)%name == attribute%name )  &
+                           THEN
                               IF ( append )  THEN
                                  !-- Append existing character attribute
@@ -1497,7 +1538,13 @@
       DO  f = 1, nf
 
+         !-- Skip initialization if file is already initialized
+         IF ( files(f)%is_init )  CYCLE
+
+         CALL internal_message( 'debug', routine_name // ': initialize file "' // &
+                                TRIM( files(f)%name ) // '"' )
+
          !-- Open file
          CALL open_output_file( files(f)%format, files(f)%name, files(f)%id, &
-                                files(f)%is_init, return_value=return_value )
+                                return_value=return_value )
 
          !-- Initialize file header:
@@ -1508,9 +1555,12 @@
          !-- End file definition
          IF ( return_value == 0 )  &
-            CALL dom_init_end( files(f)%format, files(f)%id, return_value=return_value )
-
-         !-- Write dimension values into file
+            CALL dom_init_end( files(f)%format, files(f)%id, files(f)%name, return_value )
+
          IF ( return_value == 0 )  THEN
 
+            !-- Flag file as initialized
+            files(f)%is_init = .TRUE.
+
+            !-- Write dimension values into file
             DO  d = 1, SIZE( files(f)%dimensions )
                IF ( ALLOCATED( files(f)%dimensions(d)%values_int8 ) )  THEN
@@ -1628,5 +1678,5 @@
    return_value = 0
 
-   !-- Set flag for files to be initialized
+   !-- Flag files which contain output variables as used
    file_is_used(:) = .FALSE.
    DO  f = 1, nf
@@ -1657,4 +1707,7 @@
    DO  f = 1, nf
 
+      !-- If a file is already initialized, it was already checked previously
+      IF ( files(f)%is_init )  CYCLE
+
       !-- Get number of defined dimensions
       ndim = SIZE( files(f)%dimensions )
@@ -1699,5 +1752,5 @@
 !> Open requested output file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE open_output_file( file_format, filename, file_id, is_init, return_value )
+SUBROUTINE open_output_file( file_format, filename, file_id, return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
@@ -1706,31 +1759,38 @@
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'open_output_file'  !< name of routine
 
-   INTEGER(iwp), INTENT(OUT) ::  file_id       !< file ID
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
-
-   LOGICAL, INTENT(OUT) ::  is_init  !< true if file is opened
-
+   INTEGER(iwp), INTENT(OUT) ::  file_id              !< file ID
+   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
+
+
+   return_value = 0
+   output_return_value = 0
 
    SELECT CASE ( TRIM( file_format ) )
 
       CASE ( 'binary' )
-         CALL binary_open_file( filename, file_id, return_value )
+         CALL binary_open_file( 'binary', filename, file_id, output_return_value )
 
       CASE ( 'netcdf4-serial' )
-         CALL netcdf4_serial_open_file( filename, file_id, return_value )
+         CALL netcdf4_open_file( 'serial', filename, file_id, output_return_value )
 
       CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_parallel_open_file( filename, file_id, return_value )
+         CALL netcdf4_open_file( 'parallel', filename, file_id, output_return_value )
 
       CASE DEFAULT
          return_value = 1
-         CALL internal_message( 'error', routine_name //                              &
-                                         ': file "' // TRIM( filename ) //            &
-                                         '": file format "' // TRIM( file_format ) // &
-                                         '" not supported' )
 
    END SELECT
 
-   is_init = return_value == 0
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while opening file "' // TRIM( filename ) // '"' )
+   ELSEIF ( return_value /= 0 )  THEN
+      CALL internal_message( 'error', routine_name //                              &
+                                      ': file "' // TRIM( filename ) //            &
+                                      '": file format "' // TRIM( file_format ) // &
+                                      '" not supported' )
+   ENDIF
 
 END SUBROUTINE open_output_file
@@ -1757,6 +1817,6 @@
    IF ( ALLOCATED( file%attributes ) )  THEN
       DO  a = 1, SIZE( file%attributes )
-         return_value = write_attribute( file%format, file%id, var_id=no_var_id, &
-                                attribute=file%attributes(a) )
+         return_value = write_attribute( file%format, file%id, file%name, var_id=no_var_id, &
+                                         attribute=file%attributes(a) )
          IF ( return_value /= 0 )  EXIT
       ENDDO
@@ -1771,16 +1831,16 @@
 
             !-- Initialize non-masked dimension
-            CALL init_file_dimension( file%format,                             &
-                    file%id, file%dimensions(d)%id, file%dimensions(d)%var_id, &
-                    file%dimensions(d)%name, file%dimensions(d)%data_type,     &
-                    file%dimensions(d)%length, file%dimensions(d)%is_init, return_value )
+            CALL init_file_dimension( file%format, file%id, file%name,     &
+                    file%dimensions(d)%id, file%dimensions(d)%var_id,      &
+                    file%dimensions(d)%name, file%dimensions(d)%data_type, &
+                    file%dimensions(d)%length, return_value )
 
          ELSE
 
             !-- Initialize masked dimension
-            CALL init_file_dimension( file%format,                             &
-                    file%id, file%dimensions(d)%id, file%dimensions(d)%var_id, &
-                    file%dimensions(d)%name, file%dimensions(d)%data_type,     &
-                    file%dimensions(d)%length_mask, file%dimensions(d)%is_init, return_value )
+            CALL init_file_dimension( file%format, file%id, file%name,     &
+                    file%dimensions(d)%id, file%dimensions(d)%var_id,      &
+                    file%dimensions(d)%name, file%dimensions(d)%data_type, &
+                    file%dimensions(d)%length_mask, return_value )
 
          ENDIF
@@ -1789,5 +1849,7 @@
             !-- Write dimension attributes
             DO  a = 1, SIZE( file%dimensions(d)%attributes )
-               return_value = write_attribute( file%format, file%id, file%dimensions(d)%var_id, &
+               return_value = write_attribute( file%format, file%id, file%name, &
+                                 var_id=file%dimensions(d)%var_id,              &
+                                 var_name=file%dimensions(d)%name,              &
                                  attribute=file%dimensions(d)%attributes(a) )
                IF ( return_value /= 0 )  EXIT
@@ -1807,13 +1869,15 @@
          DO  d = 1, SIZE( file%variables )
 
-            CALL init_file_variable( file%format, file%id, file%variables(d)%id, &
-                    file%variables(d)%name, file%variables(d)%data_type,         &
-                    file%variables(d)%dimension_ids,                             &
-                    file%variables(d)%is_init, file%variables(d)%is_global, return_value )
+            CALL init_file_variable( file%format, file%id, file%name,                          &
+                    file%variables(d)%id, file%variables(d)%name, file%variables(d)%data_type, &
+                    file%variables(d)%dimension_ids,                                           &
+                    file%variables(d)%is_global, return_value )
 
             IF ( return_value == 0  .AND.  ALLOCATED( file%variables(d)%attributes ) )  THEN
                !-- Write variable attribures
                DO  a = 1, SIZE( file%variables(d)%attributes )
-                  return_value = write_attribute( file%format, file%id, file%variables(d)%id, &
+                  return_value = write_attribute( file%format, file%id, file%name, &
+                                    var_id=file%variables(d)%id,                   &
+                                    var_name=file%variables(d)%name,               &
                                     attribute=file%variables(d)%attributes(a) )
                   IF ( return_value /= 0 )  EXIT
@@ -1835,17 +1899,34 @@
 !> Write attribute to file.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION write_attribute( file_format, file_id, var_id, attribute ) RESULT( return_value )
+FUNCTION write_attribute( file_format, file_id, file_name, var_id, var_name, attribute ) RESULT( return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
+   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  var_name     !< variable name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'write_attribute'  !< file format chosen for file
 
-   INTEGER(iwp) ::  file_id       !< file ID
-   INTEGER(iwp) ::  return_value  !< return value
-   INTEGER(iwp) ::  var_id        !< variable ID
+   INTEGER(iwp), INTENT(IN) ::  file_id              !< file ID
+   INTEGER(iwp)             ::  return_value         !< return value
+   INTEGER(iwp)             ::  output_return_value  !< return value of a called output routine
+   INTEGER(iwp), INTENT(IN) ::  var_id               !< variable ID
 
    TYPE(attribute_type), INTENT(IN) ::  attribute  !< attribute to be written
 
 
+   return_value = 0
+   output_return_value = 0
+
+   !-- Prepare for possible error message
+   IF ( PRESENT( var_name ) )  THEN
+      temp_string = '(file "' // TRIM( file_name ) //      &
+                    '", variable "' // TRIM( var_name ) // &
+                    '", attribute "' // TRIM( attribute%name ) // '")'
+   ELSE
+      temp_string = '(file "' // TRIM( file_name ) // &
+                    '", attribute "' // TRIM( attribute%name ) // '")'
+   ENDIF
+
+   !-- Write attribute to file
    SELECT CASE ( TRIM( file_format ) )
 
